from django.shortcuts import render

# Create your views here.

import json
from django.shortcuts import render
from plotly.offline import plot
import plots.polygon as poly
from bokeh.embed import file_html
from django.views.generic import TemplateView
import matplotlib
from django.http import JsonResponse
from plotly.graph_objs import Scatter
import plotly.graph_objects as go
from django.http import HttpResponse
import pdb;pdb.set_trace
import matplotlib.pyplot as plt
import mpld3
from plotly.subplots import make_subplots
import math
from plots import plot_helpers
from bokeh.plotting import figure, output_file, show
from bokeh.resources import CDN
from bokeh.models.widgets import Panel, Tabs
from bokeh.layouts import layout
from bokeh.models.widgets import Tabs, Panel
from bokeh.io import curdoc
from bokeh.plotting import figure
from bokeh.layouts import column
from bokeh.models import CustomJS, ColumnDataSource
from bokeh.plotting import Figure
from bokeh.models import ColumnDataSource, CustomJS, Slider
from bokeh.embed import components
from bokeh.embed import json_item
from bokeh.events import ButtonClick
import numpy as np
from bokeh.models import PolyDrawTool, PolyEditTool
from bokeh.models.callbacks import CustomJS
from bokeh.embed import json_item
import json

def index(request):

    convex_polygons = poly.create_multiple_convex_polygons(50,9)

    polygons_plot= poly.plot_polygons(convex_polygons,plot_width=300,plot_height=300,render=False)
    html_polygons = file_html(polygons_plot, CDN, "my plot")

    high_classes = poly.height_classes(convex_polygons)

    hc_tab_list = []

    # building highclass plots
    for counter,hc in enumerate(high_classes):
        hc_plot = hc.plot_hc(render=False,plot_width=300,plot_height=300)
        tab = Panel(child=hc_plot, title="High-Class {}".format(counter))
        hc_tab_list.append(tab)
    hc_tabs = Tabs(tabs=hc_tab_list)
    hc_plot_helper = file_html(hc_tabs, CDN, "my plot")

    list_containers = poly.building_containers(high_classes)
    container_tab_list=[]

    #building container plots
    for counter,container in enumerate(list_containers):
        container_plot = container.plot_container_steps(plot_width=500,colums=3,plot_height=500,render=False)
        tab = Panel(child=container_plot, title="High-Class {} -> Container {}".format(counter, counter))
        container_tab_list.append(tab)
    tabs = Tabs(tabs=container_tab_list)
    container_plot_helper= file_html(tabs, CDN, "my plot")


    mini_containers_tuple = poly.pack_mini_containers(list_containers,plot_steps=True)
    list_mini_containers = mini_containers_tuple[0]
    mini_container_plots = mini_containers_tuple[1]
    mini_plot = poly.plot_mini_containers(mini_container_plots,render=False)


    # building mini container plots
    mini_plots_tabs=[]
    for counter,m_plot in enumerate(mini_plot):
        tab = Panel(child=m_plot, title="Container {} -> Mini-Containers".format(counter))
        mini_plots_tabs.append(tab)
    mini_tabs = Tabs(tabs=mini_plots_tabs)
    mini_html_plots = file_html(mini_tabs, CDN, "my plot")

    # end container plot
    end_container = poly.End_Container(list_mini_containers)
    end_container_plot= end_container.plot_container(render=False)
    end_container_html =file_html(end_container_plot, CDN, "my plot2")
    return render(request, 'plots/index0.html', context={'polygons_plot': html_polygons,'hc_plot': hc_plot_helper,'container_plot': container_plot_helper,
                                                        'mini_container_plot': mini_html_plots, 'end_container_plot':end_container_html})

                                                        # 'high_classes': plot_high_class_list,})
            #                                            'hc_container': hc_container})





def get_json_view(request):
    convex_polygons = poly.create_multiple_convex_polygons(14, 3)
    #polygons_plot = poly.plot_polygons(convex_polygons, plot_width=300, plot_height=300, render=False)
    #html_polygons = file_html(polygons_plot, CDN, "my plot")
    list_hc = poly.height_classes(convex_polygons)
    list_containers = poly.building_containers(list_hc)

    tab_list=[]
    counter=0
    for container in list_containers:
        container_plot = container.plot_container_steps(plot_width=500, colums=3, plot_height=500, render=False)
        #tab1 = Panel(child=container_plot, title="High-Class {} -> Container {}".format(counter,counter))
        tab_list.append(file_html(container_plot, CDN, "my plot"))
        counter +=1
    #html_container = file_html(tab_list, CDN, "my plot")

    #container_plot_helper.append(html_container)
    #tabs = Tabs(tabs=tab_list)
    response =  tab_list

    mini_containers_tuple = poly.pack_mini_containers(list_containers, plot_steps=True)
    list_mini_containers = mini_containers_tuple[0]
    mini_container_plots = mini_containers_tuple[1]

    mini_plot = poly.plot_mini_containers(mini_container_plots, render=False)

    mini_plots = []
    tabs = []
    for counter, m_plot in enumerate(mini_plot):

        mini_plots.append(file_html(m_plot, CDN, "my plot"))
        # tabs.append(Panel(child=m_plot, title="circle {}".format(counter)))
    # tab =Tabs(tabs=tabs)
    mini_html_plots = mini_plots

    # fig1 = figure()
    # fig1.circle([0, 1, 2], [1, 3, 2])
    # fig2 = figure()
    # fig2.circle([0, 0, 2], [4, -1, 1])
    # fig3 = figure()
    # fig3.circle([0, 4, 3], [1, 2, 0])
    #
    # l1 = layout([[fig1, fig2]])
    # l2 = layout([[fig3]])
    #
    # tab1 = Panel(child=fig1, title="This is Tab 1")
    # tab2 = Panel(child=fig2, title="This is Tab 2")
    # tabs = Tabs(tabs=[tab1, tab2])
    # response =file_html(tabs, CDN, "my plot")
    #show(tabs)
    return render(request, 'plots/get.html', context={'containers': response,'containers2':mini_plots})





def test(request):
    # source = ColumnDataSource(data=dict(x=[1, 2, 3],
    #                                    y=[3, 2, 1]),
    #                          name='my-data-source')
    #
    # p = figure()
    # l1 = p.line("x", "y", source=source)
    # response = file_html(p, CDN, "my plot")
    # list =[1,2,3,4]

    source = ColumnDataSource(data=dict(x=[],
                                       y=[]),
                             name='my-data-source')
    p = figure(x_range=(0, 10), y_range=(0, 10), width=400, height=400,
               title='Poly Edit Tool')

    p1 = p.patches("x", "y", fill_alpha=0.4,source=source, fill_color="red")

    c1 = p.circle([], [], size=10, color='red')

    draw_tool = PolyDrawTool(renderers=[p1])
    edit_tool = PolyEditTool(renderers=[p1], vertex_renderer=c1)
    p.add_tools(draw_tool, edit_tool)
    p.toolbar.active_drag = edit_tool
    response = file_html(p, CDN, "my plot")
    return render(request, 'plots/test.html', context={"response":response, "list":list})


def hello(request):
    if request.method == 'POST':
        test = request.POST["your_name"]
        dict_poly = json.loads(test)
        print(dict_poly["x"])
        print(dict_poly["y"])
        polygon_list=[]
        polygons_x_y_tuple = list(zip(dict_poly["x"],dict_poly["y"]))
        # polygon_x_list = []
        # polygon_y_list = []
        for x,y in  polygons_x_y_tuple:
            polygon_list.append(list(zip(x,y)))
        # for x,y in polygons_x_y_tuple:
        #     polygon_x_list.append(x)
        #     polygon_y_list.append(y)
        print(polygon_list)
        real_polygons=[]
        for polygon in polygon_list:

            if len(polygon)<3:
                continue
            if polygon[0]!= polygon[-1]:
                polygon.append(polygon[0])


            polygon2 = poly.Polygon(polygon)
            print("konkav",list(polygon2.exterior.coords))
            polygon_parent_class = polygon2.convex_hull
            polygon2 = poly.Polygon2(list(polygon_parent_class.exterior.coords))
            print("convex",polygon2.shell)
            real_polygons.append(polygon2)
        # print(polygon_list)
        # q = map(list, zip(*polygon_list))
        # s=  json.loads(test)
        # x = s["x"]
        # y = s["y"]
        # source = ColumnDataSource(data=dict(x=polygon_x_list, y=polygon_y_list),name='my-data-source')
        # print(test)
        plot = poly.plot_polygons_in_single_plot(real_polygons,render=False)
        # plot = poly.plot_polygons(real_polygons,render=False)
        # print(type(test))
        # p = figure()
        # p.multi_line("x", "y", source=source)
        response = file_html(plot, CDN, "my plot")

        # polygon = Polygon(polygon_points)
        # polygon_parent_class = polygon.convex_hull
        # polygon2 = Polygon2(list(polygon_parent_class.exterior.coords))
        return HttpResponse(response)